// Это решение тоже работет. В ДП здесь переход проще, но оно использует больше памяти и приходится
// хитро кодировать состояние, из которого мы пришли.

#include <cassert>
#include <cstdio>
#include <cstring>
#include <iostream>
#include <utility>
#include <vector>

using namespace std;

const int maxn = 100;

int n, a[maxn];
int m, b[maxn];

unsigned char d[maxn + 1][maxn + 1][maxn + 1][maxn + 1];
unsigned char fr[maxn + 1][maxn + 1][maxn + 1][maxn + 1];

int ans[maxn][maxn];

int best = 0xff;
int best_i = 0;
int best_j = 0;

void try_improve(int i, int j, int k, int q, int i1, int j1, int k1, int q1) {
    int add = (q > 0 && j1 == 1) ? 1 : 0;
    if (d[i][j][k][q] + add < d[i1][j1][k1][q1]) {
        //cout << i << j << k << q << " -> " << i1 << j1 << k1 << q1 << " + " << add << endl;
        d[i1][j1][k1][q1] = d[i][j][k][q] + add;
        bool seat = (k != k1 || q != q1);
        fr[i1][j1][k1][q1] = j + (seat ? 128 : 0);

        if (k1 == n && q1 == 0 && d[i1][j1][k1][q1] < best) {
            best = d[i1][j1][k1][q1];
            best_i = i1;
            best_j = j1;
        }
    }
}

void restore(int i, int j, int k, int q) {
    //cout << "restore " << i << j << k << q << endl;
    assert(d[i][j][k][q] != 0xff);

    if (!(i + j + k + q)) {
        return;
    }

    int i1 = i;
    int j1 = j;
    j1--;
    if (j1 < 0) {
        i1--;
        j1 = b[i1] - 1;
    }

    int k1 = k;
    int q1 = q;

    bool seat = (fr[i][j][k][q] >= 128);
    if (seat) {
        q1--;
        if (q1 < 0) {
            k1--;
            q1 = a[k1] - 1;
        }
        ans[k1][i1]++;
    }

    restore(i1, (j == 0 ? fr[i][j][k][q] % 128 : j1), k1, q1);
}

int main() {
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);

    cin >> n;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    cin >> m;
    for (int i = 0; i < m; i++) {
        cin >> b[i];
    }

    memset(d, 0xff, sizeof(d));
    d[0][0][0][0] = 0;

    for (int i = 0; i < m; i++) {
        for (int j = 0; j <= b[i]; j++) {
            for (int k = 0; k < n; k++) {
                for (int q = 0; q < a[k]; q++) {
                    if (d[i][j][k][q] == 0xff) continue;
                    int i1 = i;
                    int j1 = j + 1;
                    if (j1 > b[i]) {
                        i1++;
                        j1 = 1;
                    }
                    int k1 = k;
                    int q1 = q + 1;
                    if (q1 == a[k]) {
                        k1++;
                        q1 = 0;
                    }
                    if (i1 < m || j1 == 0) {
                        try_improve(i, j, k, q, i1, j1, k1, q1);
                    }
                    try_improve(i, j, k, q, i + 1, 0, k, q);
                }
            }
        }
    }

    restore(best_i, best_j, n, 0);

    for (int i = 0; i < n; i++) {
        int p = 0;
        for (int j = 0; j < m; j++) {
            if (ans[i][j]) p++;
        }
        cout << p << endl;
        for (int j = 0; j < m; j++) {
            if (ans[i][j]) cout << j + 1 << " " << ans[i][j] << endl;
        }
    }
}
