#include <cassert>
#include <cstdlib>
#include <iostream>
#include <sstream>

using namespace std;

int b[100];

int main(int argc, char* argv[])
{
    int n, max_a, m, max_b, randseed;
    istringstream ss1(argv[1]);
    ss1 >> n;
    istringstream ss2(argv[2]);
    ss2 >> max_a;
    istringstream ss3(argv[3]);
    ss3 >> m;
    istringstream ss4(argv[4]);
    ss4 >> max_b;
    istringstream ss5(argv[5]);
    ss5 >> randseed;

    srand(randseed);
    assert(n * max_a <= m * max_b);

    int sum_a = 0;
    cout << n << endl;
    for (int i = 0; i < n; i++) {
        int d_size = rand() % max_a + 1;
        cout << d_size;
        if (i < n - 1) cout << " ";
        sum_a += d_size;
    }
    cout << endl;

    int sum_b = 0;
    for (int i = 0; i < m; i++) {
        b[i] = rand() % max_b + 1;
        sum_b += b[i];
    }
    for (int k = 0; k < sum_a - sum_b; k++) {
        while (true) {
            int i = rand() % m;
            if (b[i] < max_b) {
                b[i]++;
                break;
            }
        }
    }

    cout << m << endl;
    for (int i = 0; i < m; i++) {
        cout << b[i];
        if (i < m - 1) cout << " ";
    }
    cout << endl;

    return 0;
}
